//
//  CLServer.m
//  NKDemo
//
//  Created by Darcy Liu on 8/25/12.
//  Copyright (c) 2012 Close To U. All rights reserved.
//

#import "CLServer.h"

@implementation CLServer

- (id)init {
    self = [super init];
    if(self) {
        // TODO
    }
    return self;
}

- (void)dealloc {
    [issues release];
    [super dealloc];
}

- (NSInteger)numberOfIssues{
    if(issues){
        return [issues count];
    }
    return 0;
}

- (NSDictionary *)issueAtIndex:(NSInteger)index {
    return [issues objectAtIndex:index];
}

- (NSString *)titleOfIssueAtIndex:(NSInteger)index {
    return [[self issueAtIndex:index] objectForKey:@"Title"];
}

- (NSString *)nameOfIssueAtIndex:(NSInteger)index {
    return [[self issueAtIndex:index] objectForKey:@"Name"];    
}

- (void)addIssuesInNewsstand {
    NKLibrary *library = [NKLibrary sharedLibrary];
    [issues enumerateObjectsUsingBlock:^(id obj, NSUInteger idx, BOOL *stop) {
        NSString *name = [(NSDictionary *)obj objectForKey:@"Name"];
        NKIssue *nkIssue = [library issueWithName:name];
        if(!nkIssue) {
            nkIssue = [library addIssueWithName:name date:[(NSDictionary *)obj objectForKey:@"Date"]];
        }
        //NSLog(@"Issue: %@",nkIssue);
    }];
}

- (void)getIssuesList{
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_LOW, 0),
       ^{
           NSArray *tmpIssues = [NSArray arrayWithContentsOfURL:[NSURL URLWithString:@"http://ioio.name/demo/newsstand/issues.plist"]];
           if(!tmpIssues) {
               dispatch_async(dispatch_get_main_queue(), ^{
                   [[NSNotificationCenter defaultCenter] postNotificationName:IssuesFailedUpdateNotification object:self];
               });
           } else {
               if(issues) {
                   [issues release];
               }
               issues = [[NSArray alloc] initWithArray:tmpIssues];
               [self addIssuesInNewsstand];
               dispatch_async(dispatch_get_main_queue(), ^{
                   [[NSNotificationCenter defaultCenter] postNotificationName:IssuesDidUpdateNotification object:self];
               });
           }
       });
}

- (NSURL *)contentURLForIssueWithName:(NSString *)name {
    __block NSURL *contentURL=nil;
    [issues enumerateObjectsUsingBlock:^(id obj, NSUInteger idx, BOOL *stop) {
        NSString *aName = [(NSDictionary *)obj objectForKey:@"Name"];
        if([aName isEqualToString:name]) {
            contentURL = [[NSURL URLWithString:[(NSDictionary *)obj objectForKey:@"Content"]] retain];
            *stop=YES;
        }
    }];
    NSLog(@"Content URL for issue with name %@ is %@",name,contentURL);
    return [contentURL autorelease];
}

-(NSString *)downloadPathForIssue:(NKIssue *)issue {
    return [[issue.contentURL path] stringByAppendingPathComponent:@"preview.pdf"];
}

@end
